#ifndef ANUGAVIS_HH
#define ANUGAVIS_HH

/* The main controller object. */

#include <list>
#include <string>
#include <boost/shared_ptr.hpp>
#include <SDL.h>
#include "height_quantity.hh"
#include "sww_file.hh"
#include "vector.hh"

using boost::shared_ptr;
using std::list;
using std::string;

class AnugaVis{
public:
  AnugaVis(const string &sww_file, int width, int height);
  ~AnugaVis(void);
  void add_HeightQuantity(shared_ptr<HeightQuantity> &height);
  void run(void);
private:
  void init_camera(void);
  void init_SDL(int width, int height);
  void init_OpenGL(int width, int height);
  bool step(void);
  Vector eye;
  Vector focus;
  int frame;
  list<shared_ptr<HeightQuantity> > heights;
  bool paused;
  SDL_Surface *screen;
  shared_ptr<SWWFile> sww_file;
};

#endif
